#ifndef _IDBCMANAGER_H_
#define _IDBCMANAGER_H_

#ifdef WIN32
    #define FUNCCALL __stdcall
#else
    #define FUNCCALL
#endif

#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C
#endif

typedef unsigned int     uint32;
typedef unsigned int     DBCHandle;
typedef unsigned char    uint8;
typedef unsigned short   uint16;
typedef unsigned long long uint64;
typedef uint8 ERR_CODE;
//error code
#define ERR_SUCCESS            0
#define ERR_FAILED             1
#define ERR_MULTI_TRANSMITTING 2 //֡䷢

#define INVALID_DBC_HANDLE        -1 // ЧDBC

#define _MAX_FILE_PATH_           260 //ļ·
#define _DBC_NAME_LENGTH_         127  //
#define _DBC_COMMENT_MAX_LENGTH_  200 //ע
#define _DBC_UNIT_MAX_LENGTH_     10  //λ
#define _DBC_SIGNAL_MAX_COUNT_    128 //һϢеźŵĿ

//multiplexer type
#define MUTIPLEXER_NONE     0
#define MUTIPLEXER_M_VALUE  1
#define MUTIPLEXER_M_SWITCH 2

struct DBCSignal
{
    uint32 nStartBit; // ʼλ
    uint32 nLen;	// λ
    double nFactor; // ת
    double nOffset;	// תƫ ʵֵ=ԭʼֵ*nFactor+nOffset
    double nMin;    // Сֵ
    double nMax;	// ֵ
    double nValue;  //ʵֵ
    uint64 nRawValue;//ԭʼֵ
    bool is_signed; //1:з, 0:޷
    bool is_motorola;//ǷĦʽ
    uint8 multiplexer_type;//see 'multiplexer type' above
    uint8 val_type;//0:integer, 1:float, 2:double
    uint32 multiplexer_value;
    char unit[_DBC_UNIT_MAX_LENGTH_+1];//λ
    char strName[_DBC_NAME_LENGTH_+1];  //
    char strComment[_DBC_COMMENT_MAX_LENGTH_+1];  //ע
    char strValDesc[_DBC_NAME_LENGTH_+1];  //ֵ
};

struct DBCMessage
{
    uint32 nSignalCount; //ź
    uint32 nID;
    uint32 nSize;	//ϢռֽĿ
    double nCycleTime;//
    uint8 nExtend; //1:չ֡, 0:׼֡
    DBCSignal vSignals[_DBC_SIGNAL_MAX_COUNT_]; //źż
    char strName[_DBC_NAME_LENGTH_+1];  //
    char strComment[_DBC_COMMENT_MAX_LENGTH_+1];    //ע
};

#define PROTOCOL_J1939   0
#define PROTOCOL_OTHER 1
struct FileInfo
{
    char strFilePath[_MAX_FILE_PATH_+1]; //dbcļ·
    uint8 type; //dbcЭ, j1939ѡPROTOCOL_J1939, ЭѡPROTOCOL_OTHER
    uint8 merge;//1:е, ּ֧ضļ;0ԭ
};

//ֵ뺬, 3 "Not Supported" 2 "Error" 1 "Not Defined"
struct ValDescPair
{
    double value;
    char desc[_DBC_NAME_LENGTH_+1];
};

/*
˵ûʵʷݹ, ֻṩ͵,
          Ҫʵָûصʵݷ͡
    [in]ctx-ص
    [in]pObj-Ҫ͵
  ֵtrueͳɹ
*/
typedef bool (FUNCCALL *OnSend)(void* ctx, void* pObj);

/*
˵֡ɺص, 漰֡ҲԲʵָûص
    [in]ctx-ص
    [in]pMsg-صDBCϢ
    [in]data-֡ʵ
    [in]nLen-֡ݵֽĿ
    [in]nDirection-֡Ĵ䷽ 1:, 0:
  ֵvoid
*/
typedef void (FUNCCALL *OnMultiTransDone)(void* ctx, DBCMessage* pMsg, uint8* data, uint16 nLen, uint8 nDirection);

/*
˵ʼģ顣
  ֵINVALID_DBC_HANDLE:ʼʧ
          ֵ:ʼɹ
          ֵʹõ
*/
EXTERN_C  DBCHandle FUNCCALL DBC_Init();

/*
˵ͷԴ, DBC_Initʹ
    [in]hDBC-, DBC_Loadķֵ
*/
EXTERN_C  void FUNCCALL DBC_Release( DBCHandle hDBC );

/*
˵DBCʽļ
    [in]hDBC-, DBC_Loadķֵ
    [in]pFileInfo-ļϢ, οstruct FileInfo
  ֵtrueسɹ
*/
EXTERN_C  bool FUNCCALL DBC_LoadFile( DBCHandle hDBC, const FileInfo* pFileInfo );

/*
˵ȡһϢ
    [in]hDBC-, DBC_Loadķֵ
    [out]pMsg 洢ϢϢ
  ֵtrueʾɹ
*/
EXTERN_C  bool FUNCCALL DBC_GetFirstMessage( DBCHandle hDBC, DBCMessage* pMsg );

/*
˵ȡһϢ
    [in]hDBC-, DBC_Loadķֵ
    [out]pMsg 洢ϢϢ
  ֵtrueʾɹ
*/
EXTERN_C  bool FUNCCALL DBC_GetNextMessage( DBCHandle hDBC, DBCMessage* pMsg );

/*
˵IDȡϢ
    [in]hDBC-, DBC_Loadķֵ
    [in]nID-ϢID
    [out]pMsg 洢ϢϢ
  ֵtrueʾɹ
*/
EXTERN_C  bool FUNCCALL DBC_GetMessageById( DBCHandle hDBC, uint32 nID, DBCMessage* pMsg );
/*
˵ȡϢ
    [in]hDBC-, DBC_Loadķֵ
  ֵϢ
*/
EXTERN_C  uint32 FUNCCALL DBC_GetMessageCount( DBCHandle hDBC );

/*
˵DBCЭ֡
    [in]hDBC-, DBC_Loadķֵ
    [in]pObj ԭʼ֡
    [out]pMsg 
  ֵtrueʾɹ
*/
EXTERN_C  bool FUNCCALL DBC_Analyse( DBCHandle hDBC, const void* pObj, DBCMessage* pMsg );

/*
˵Ҫøúѽյ֡ݴ,
          漰֡Ҫ, ޷ʵ豸
    [in]hDBC-, DBC_Loadķֵ
    [in]pObj ԭʼ֡
  ֵvoid
*/
EXTERN_C  void FUNCCALL DBC_OnReceive( DBCHandle hDBC, const void* pObj );

/*
˵ʵʷݵĴ, 漰ݷʱãֻҪһΡ
    [in]hDBC-, DBC_Loadķֵ
    [in]senderصָ
    [in]ctx-ص
  ֵvoid
*/
EXTERN_C  void FUNCCALL DBC_SetSender( DBCHandle hDBC, OnSend sender, void* ctx );

/*
˵ô֡ݵĻصֻҪһ
    [in]hDBC-, DBC_Loadķֵ
    [in]OnMultiTransDoneصָ
    [in]ctx-ص
  ֵvoid
*/
EXTERN_C  void FUNCCALL DBC_SetOnMultiTransDoneFunc( DBCHandle hDBC, OnMultiTransDone func, void* ctx);
/*
˵DBCϢ
    [in]hDBC-, DBC_Loadķֵ
    [in]pMsg Ҫ͵Ϣ
  ֵο//error code
*/
EXTERN_C  ERR_CODE FUNCCALL DBC_Send( DBCHandle hDBC, const DBCMessage* pMsg );

/*
˵ȡźŵֵ뺬Ը
    [in]hDBC-, DBC_Loadķֵ
    [in]msg_id, ϢID
    [in]signal_name, ź
  ֵֵ뺬Ը
*/
EXTERN_C  uint32 FUNCCALL DBC_GetValDescPairCount( DBCHandle hDBC, uint32 msg_id, char* signal_name);
/*
˵ȡֵ뺬ԡ
    [in]hDBC-, DBC_Loadķֵ
    [in]msg_id, ϢID
    [in]signal_name, ź
    [in,out]pair ,߹,СΪDBC_GetValDescPairCountֵ
  ֵtrueʾɹ
*/
EXTERN_C  void FUNCCALL DBC_GetValDescPair( DBCHandle hDBC, uint32 msg_id, char* signal_name, ValDescPair* pair);
/*
˵ԭʼݽΪDBCMessage
    [in]hDBC-, DBC_Loadķֵ
    [out]pMsg 
    [in]pObj ԭʼ֡
    [in]nCount ԭʼ֡ݸ
  ֵtrueʾɹ
*/
EXTERN_C  bool FUNCCALL DBC_Decode( DBCHandle hDBC, DBCMessage* pMsg, const void* pObj, uint32 nCount );
/*
˵DBCMessageΪԭʼ
    [in]hDBC-, DBC_Loadķֵ
    [out]pObj ԭʼݻ
    [in,out]pObj С, ʱΪʵԭʼݸ
    [in]pMsg ҪϢ
  ֵtrueʾɹ
*/
EXTERN_C  bool FUNCCALL DBC_Encode( DBCHandle hDBC, void* pObj, uint32* nCount, const DBCMessage* pMsg );

#endif // _IDBCMANAGER_H_
